#include <Servo.h>

void checkLEDs();
void cautious();
void fast();
void slowly();
void stay();
void backAndForth();
void peekaboo();
void stay();
void feint();
void sneaky();
void goaway();
void surrender();

int switchPin = 12;
int redLED = 10;
int greenLED = 9;

int pos = 0;
int count = 0;

int action = 1; // what action number are we on?

Servo lid; // closed is 84, max open is 80
Servo arm; // resting is 0, switch off is is 80

int lidClosed = 84; // If your lid is too closed or not closed enough, adjust this number up or down
int lidOpen = 50; // lid states, just to make it a little easier when we're opening and closing it

int armResting = 0; // arm states
int switchOff = 80;

void setup()
{
  pinMode(redLED, OUTPUT);     // LED as output
  pinMode(greenLED, OUTPUT);     // LED as output
  pinMode(switchPin, INPUT);    // button as input
  digitalWrite(switchPin, HIGH); // turns on pull-up resistor after input

  lid.attach(7); // attach the servo on pin 7
  arm.attach(8); // attach the servo on pin 8

  arm.write(armResting); // set both servos to closed position
  lid.write(lidClosed);
}

void loop()
{
  bool switched = ! digitalRead(switchPin); // set the switched value to the opposite of the switch state (we're using the internal pull-up resistor so everything is reversed)

  checkLEDs();

  if (switched) {
    action = random(1, 12);
    if (action == 1) {
      cautious();
      action += 1;
    }
    else if (action == 2) {
      fast();
      action += 1;
    }
    else if (action == 3) {
      slowly();
      action += 1;
    }
    else if (action == 4) {
      staystaystay();
      action += 1;
    }
    else if (action == 5) {
      backAndForth();
      action += 1;
    }
    else if (action == 6) {
      peekaboo();
      action += 1;
    }
    else if (action == 7) {
      stay();
      action += 1;
    }
    else if (action == 8) {
      feint();
      action += 1;
    }
    else if (action == 9) {
      sneaky();
      action += 1;
    }
    else if (action == 10) {
      goaway();
      action += 1;
    }
    else if (action == 11) {
      surrender();
      action += 1;
    }
  }
}

void checkLEDs() {
  delay(250);
  digitalWrite(redLED, digitalRead(switchPin));
  digitalWrite(greenLED, ! digitalRead(switchPin));
}

void cautious() {
  delay(500); // give the tormentor a while to take their hand away
  lid.write(lidOpen);
  delay(1000);
  arm.write(switchOff);
  checkLEDs();
  delay(500);
  arm.write(armResting);
  delay(500);
  lid.write(lidClosed);
}

void fast() {
  delay(250);
  lid.write(lidOpen);
  arm.write(switchOff);
  checkLEDs();
  arm.write(armResting);
  lid.write(lidClosed);
}

void slowly() {
  for (pos = 84; pos > 50; pos --) {
    lid.write(pos);
    delay(25);
  }
  delay(7000);
  arm.write(switchOff);
  checkLEDs();
  arm.write(armResting);
  lid.write(lidClosed);
}

void staystaystay() {
  lid.write(lidOpen);
  delay(160);
  arm.write(switchOff);
  checkLEDs();
  arm.write(45);
  delay(750);
  arm.write(switchOff);
  delay(160);
  arm.write(60);
  delay(160);
  arm.write(switchOff);
  delay(160);
  arm.write(60);
  delay(160);
  arm.write(switchOff);
  delay(160);
  arm.write(45);
  delay(160);
  arm.write(armResting);
  delay(160);
  lid.write(lidClosed);
}

void backAndForth() {
  while (count < 5) {
    if (! digitalRead(switchPin)) {
      lid.write(lidOpen);
      arm.write(switchOff);
      checkLEDs();
      arm.write(armResting);
      lid.write(lidClosed);
      count ++;
    }
  }
}

void peekaboo() {
  lid.write(lidOpen);
  delay(500);
  lid.write(lidClosed);
  delay(500);
  lid.write(lidOpen);
  delay(500);
  lid.write(lidClosed);
  delay(500);
  lid.write(lidOpen);
  delay(500);
  lid.write(lidClosed);
  delay(500);
  lid.write(lidOpen);
  delay(500);
  lid.write(lidClosed);
  delay(1500);
  lid.write(lidOpen);
  arm.write(switchOff);
  checkLEDs();
  arm.write(armResting);
  lid.write(lidClosed);
}

void stay() {
    lid.write(lidOpen);
    arm.write(switchOff);
    checkLEDs();
    delay(1000);
    for (pos = switchOff; pos > 0; pos --) {
      arm.write(pos);
      delay(25);
  }
   for (pos = 50; pos < 84; pos ++) {
    lid.write(pos);
    delay(25);
  }
}

void feint() {
  lid.write(lidOpen);
  arm.write(45);
  delay(250);
  arm.write(55);
  delay(100);
  arm.write(45);
  delay(370);
  arm.write(55);
  delay(100);
  arm.write(45);
  delay(750);
  arm.write(55);
  delay(100);
  arm.write(45);
  delay(295);
  arm.write(switchOff);
  checkLEDs();
  arm.write(armResting);
  lid.write(lidClosed);
}

void sneaky() {
  for (pos = 84; pos > 60; pos --) {
    lid.write(pos);
    delay(25);
  }
  for (pos = 0; pos > 90; pos ++) {
    arm.write(pos);
    delay(25);
  }
  checkLEDs();
  for (pos = 90; pos > 0; pos --) {
    arm.write(pos);
    delay(25);
  }
  for (pos = 70; pos <84; pos ++) {
    lid.write(pos);
    delay(25);
  }
}

void goaway() {
  lid.write(lidOpen);
  arm.write(switchOff);
  checkLEDs();
  delay(4000);
    for (pos = 80; pos > 0; pos --) {
    arm.write(pos);
    delay(25);
  }
  for (pos = lidOpen; pos <84; pos ++) {
    lid.write(pos);
    delay(25);
  }
}

void surrender() {
  lid.write(lidOpen);
  arm.write(45);
  delay(2000);
  arm.write(armResting);
  lid.write(lidClosed);
  delay(6000);
  lid.write(lidOpen);
  arm.write(switchOff);
  checkLEDs();
  arm.write(armResting);
  lid.write(lidClosed);
}
